//Libraries
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <LiquidCrystal_I2C.h>
#include <YoutubeApi.h>
#include <ArduinoJson.h>

//--------------------------------------------------
//WI-FI Settings
char ssid[] = ""; //Replace with your network SSID Wifi (name)
char password[] = ""; //Replace with your network key Wifi
//--------------------------------------------------
//YouTube API
#define API_KEY ""  //Replace with your google apps API Token
#define CHANNEL_ID "" //Replace with your youtube channel ID
//--------------------------------------------------
WiFiClientSecure client;
YoutubeApi api(API_KEY, client);

LiquidCrystal_I2C lcd(0x27, 20, 2);

int ytsubcount;
String ytsubcountString = "";
//--------------------------------------------------
void setup()
{
  Serial.begin(9600);

  //Set WiFi to station mode and disconnect from an AP if it was Previously connected
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);

  // Attempt to connect to Wifi network:
  Serial.print("Connecting Wifi: ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED)
  {
    Serial.print(".");
    delay(500);
  }
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  IPAddress ip = WiFi.localIP();
  Serial.println(ip);

  //Required if you are using ESP8266 V2.5 or above
  client.setInsecure();

  //If you want to enable some extra debugging
  api._debug = true;

  //Initiate LCD
  lcd.init(); //initialize the lcd
  lcd.backlight(); //open the backlight 
}
//--------------------------------------------------
void loop() 
{
    if(api.getChannelStatistics(CHANNEL_ID))
    {
      Serial.println("---------Stats---------");
      Serial.print("Subscriber Count: ");
      ytsubcount = api.channelStats.subscriberCount;
      Serial.println(ytsubcount);
      Serial.println("------------------------");
      //--------------------------------------------------
      //LCD Output
      lcd.clear();
      lcd.setCursor(1,0);
      lcd.print("YouTube Subscribers");

      //ytsubcount = 1000000;
      ytsubcountString = "";
      int CommaCounter = -2;
      for (int i = String(ytsubcount).length(); i >= 0; i--)
      {
        CommaCounter++;
        if (CommaCounter >= 3)
        {
          ytsubcountString = "," + ytsubcountString;
          CommaCounter = 0;
        }
        
        ytsubcountString = String(ytsubcount).substring(i,i+1) + ytsubcountString;
      }
      lcd.setCursor(1,1);
      lcd.print(ytsubcountString);
    }
    delay(60 * 1000); //Wait 60 Seconds
}
